/* Generated By:JavaCC: Do not edit this line. Analyzer.java */
        package org.thema.lucsim.parser;

        import org.thema.lucsim.engine.*;

        import org.thema.lucsim.engine.RulesBlock.BlockType;

        import java.util.ArrayList;

        /**
         * Class allowing the analysis of the transition rules.
	 * @author rgrillot
         * @author alexis
	 */

        public class Analyzer implements AnalyzerConstants {

                private int block = 0;
                private int regle = 0;

                private ArrayList <Rule> rulesArr = null;
                private ArrayList<Token> tokenArr = null;

                private boolean conditionBlock = false;

                                        /************************************************/
                                        /* 		E X P L I C A T I O N -		*/
                                        /*		    G R A M M A R 		*/
                                        /************************************************/



/*
	__________

	Grammaire des conditions (règle et block)
	__________


	O ->  X or O 				Dans l'écriture des  fonctions, la  grammaire est reproduite  d'une facon  legerement 		
	    | X					différente pour éviter de rechercher des tokens qui ne sont pas immédiatement présent			
						dans la phrase.  
	X ->  A xor X				
	    | A					ex.
							O -> X or O | X
	A ->  N and A 				Ou est le or? Cela pose probleme
	    | N

	N -> not ( N )				On écrit donc
	    | C						O -> X ( <OR> O )?
						Un fois le X étudier, on regarde si deriere il y a un token OR, si on reprend au O
	C ->  E  =  C
	    | E  >  C
	    | E  <  C
	    | E  <> C
	    | E  >= C
	    | E  <= C				La règle à été écrite de la maniere suivante pour plusieurs avantages:
	    | E
							- La recursivité a gauche n'existe pas
	E ->  M + E					- Les fonctions (et autres) peuvent s'imbricker entres elles ex. quand on arrive
	    | M - E					  a trouver une fonction, son argument revient a la regle O, c'est a dire qu'elle
	    | M						  peut prendre n'importe quoi en argument, meme opérateur logiques. De toute maniere
							  lors de l'éexecution, tout retourne un nombre
	M ->  T mod M					- Les perentheses sont tres simples a utiliser, elle peuvent se mettre partout
	    | T						- etc

	T ->  F * T
	    | F / T				___________
	    | F					Indications
						___________
	F ->  ( O )
	    | true
	    | false				true/false retourne 1/0 lors de l'execution
	    | integer				layer est un nom de couche, et retourne en exe le numero de l'état sur la couche de la cellule en cours d'exe
	    | integer meter			state est un nom d'etat (de la couche principale, les stat n'ont pas de nom), utilisé lors des fonction
	    | integer degree			les fonctions peuvent prendre n'importe quoi en parametre. exemple: integer meter. Lors de l'exe, integer meter se transforme en nombre de cellule
	    | integer percent
	    | float
	    | float meter
	    | float degree
	    | float percent
	    | S

	S ->  layer ? integer
	    | layer . L
	    | layer
	    | state
	    | L

	L -> nbCell ( O )
	    | autres fonctions globales et math
            | D

        D -> nbCellNeu( O ) 
            | autres fonctions locales



 */
                                                /****************************************/
                                                /* 		R E G L E S		*/
                                                /****************************************/
  final public void validationStart(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case WHILE:
      case IF:
      case REPEAT:
      case OPEN_BRA:
      case ALL:
      case NAME:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IF:
        jj_consume_token(IF);
        jj_consume_token(OPEN_PAR);
                    tokenArr  = new ArrayList<Token>();
                    conditionBlock = true;
        O(project);
        jj_consume_token(CLOSE_PAR);
        jj_consume_token(OPEN_BRA);
                        project.getRulesBlocks().add(new RulesBlock(BlockType.IF, new Condition(tokenArr)));
                        conditionBlock = false;
        label_2:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ALL:
          case NAME:
            ;
            break;
          default:
            jj_la1[1] = jj_gen;
            break label_2;
          }
          validationRule(project);
        }
        jj_consume_token(CLOSE_BRA);
                    block = block + 1 ; regle = 0;
        break;
      case WHILE:
        jj_consume_token(WHILE);
        jj_consume_token(OPEN_PAR);
                    tokenArr  = new ArrayList<Token>();
                    conditionBlock = true;
        O(project);
        jj_consume_token(CLOSE_PAR);
        jj_consume_token(OPEN_BRA);
                        project.getRulesBlocks().add(new RulesBlock(BlockType.WHILE, new Condition(tokenArr)));
                        conditionBlock = false;
        label_3:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ALL:
          case NAME:
            ;
            break;
          default:
            jj_la1[2] = jj_gen;
            break label_3;
          }
          validationRule(project);
        }
        jj_consume_token(CLOSE_BRA);
                    block = block + 1 ; regle = 0;
        break;
      case REPEAT:
        jj_consume_token(REPEAT);
        jj_consume_token(OPEN_PAR);

        t = jj_consume_token(INTEGER);
                                project.getRulesBlocks().add(new RulesBlock(Integer.parseInt(t.image)));
        jj_consume_token(CLOSE_PAR);
        jj_consume_token(OPEN_BRA);
        label_4:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ALL:
          case NAME:
            ;
            break;
          default:
            jj_la1[3] = jj_gen;
            break label_4;
          }
          validationRule(project);
        }
        jj_consume_token(CLOSE_BRA);
                    block = block + 1 ; regle = 0;
        break;
      case OPEN_BRA:
        jj_consume_token(OPEN_BRA);
                    project.getRulesBlocks().add(new RulesBlock(BlockType.SIMPLE));
        label_5:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ALL:
          case NAME:
            ;
            break;
          default:
            jj_la1[4] = jj_gen;
            break label_5;
          }
          validationRule(project);
        }
        jj_consume_token(CLOSE_BRA);
                    block = block + 1 ; regle = 0;
        break;
      case ALL:
      case NAME:
                                project.getRulesBlocks().add(new RulesBlock(BlockType.NOBLOCK));
        validationRule(project);
                            block = block + 1 ; regle = 0;
        break;
      default:
        jj_la1[5] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(0);
  }

  final protected void validationRule(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
                tokenArr  = new ArrayList<Token>();
                rulesArr = new ArrayList <Rule>();
                Rule rule = new Rule();
                rulesArr.add(rule);
                project.getRulesBlocks().get(block).add(rule);
    validationTransition(project, rule);
    jj_consume_token(COLON);
    O(project);
    jj_consume_token(SEMI_COLON);
                for(int i = 0 ; i< rulesArr.size() ; i ++ ) {
                        project.getRulesBlocks().get(block).getElement(regle).setCondition(new Condition(tokenArr));
                        regle ++;
                }
  }

  final protected void validationTransition(Project project, Rule rule) throws ParseException, NumberFormatException, UnknownStateException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ALL:
      t = jj_consume_token(ALL);
                    rulesArr.get(rulesArr.size()-1).setAllInit();
      break;
    case NAME:
      t = jj_consume_token(NAME);
                        rulesArr.get(rulesArr.size()-1).setInitState(project.getStates().getState(t.image));
      label_6:
      while (true) {
        if (jj_2_1(2)) {
          ;
        } else {
          break label_6;
        }
        jj_consume_token(COMMA);
        t = jj_consume_token(NAME);
                                Rule rule2 = new Rule();
                                rule2.setInitState(project.getStates().getState(t.image));
                                rulesArr.add(rule2);
                                project.getRulesBlocks().get(block).add(rule2);
      }
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    jj_consume_token(ARROW);
    t = jj_consume_token(NAME);
                for(int i = 0 ; i < rulesArr.size() ; i ++){
                    rulesArr.get(i).setFinalState(project.getStates().getState(t.image));
                }
  }

  final protected void O(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    X(project);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OR:
      t = jj_consume_token(OR);
                             tokenArr.add(t);
      O(project);
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
  }

  final protected void X(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    A(project);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XOR:
      t = jj_consume_token(XOR);
                              tokenArr.add(t);
      X(project);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
  }

  final protected void A(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    N(project);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
      t = jj_consume_token(AND);
                              tokenArr.add(t);
      A(project);
      break;
    default:
      jj_la1[9] = jj_gen;
      ;
    }
  }

  final protected void N(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NOT:
      t = jj_consume_token(NOT);
                              tokenArr.add(t);
      N(project);
      break;
    case TRUE:
    case FALSE:
    case NBCELLNEU:
    case NBCELLMOO:
    case NBCELLSQ:
    case NBCELLCIR:
    case PCELLSQ:
    case PCELLCIR:
    case NBCELLANG:
    case PCELLANG:
    case CELLDURATION:
    case NORTH:
    case SOUTH:
    case EAST:
    case WEST:
    case NORTH_EAST:
    case NORTH_WEST:
    case SOUTH_EAST:
    case SOUTH_WEST:
    case NBCELL:
    case PCELL:
    case STEP:
    case NBSAMESTEP:
    case NBCELLDURATION:
    case RANDOM:
    case INT:
    case ROUND:
    case OPEN_PAR:
    case INTEGER:
    case FLOAT:
    case NAME:
      C(project);
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final protected void C(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    E(project);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQUAL:
    case GEQ:
    case LEQ:
    case NEQ:
    case GREAT:
    case LESS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQUAL:
        t = jj_consume_token(EQUAL);
                                tokenArr.add(t);
        C(project);
        break;
      case GEQ:
        t = jj_consume_token(GEQ);
                                tokenArr.add(t);
        C(project);
        break;
      case LEQ:
        t = jj_consume_token(LEQ);
                                tokenArr.add(t);
        C(project);
        break;
      case NEQ:
        t = jj_consume_token(NEQ);
                                tokenArr.add(t);
        C(project);
        break;
      case GREAT:
        t = jj_consume_token(GREAT);
                                tokenArr.add(t);
        C(project);
        break;
      case LESS:
        t = jj_consume_token(LESS);
                                tokenArr.add(t);
        C(project);
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[12] = jj_gen;
      ;
    }
  }

  final protected void E(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    M(project);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case PLUS:
    case MINUS:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        t = jj_consume_token(PLUS);
                                tokenArr.add(t);
        E(project);
        break;
      case MINUS:
        t = jj_consume_token(MINUS);
                                tokenArr.add(t);
        E(project);
        break;
      default:
        jj_la1[13] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[14] = jj_gen;
      ;
    }
  }

  final protected void M(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    T(project);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case MODULO:
      t = jj_consume_token(MODULO);
                                  tokenArr.add(t);
      M(project);
      break;
    default:
      jj_la1[15] = jj_gen;
      ;
    }
  }

  final protected void T(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    F(project);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TIMES:
    case DIVIDE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TIMES:
        t = jj_consume_token(TIMES);
                                 tokenArr.add(t);
        T(project);
        break;
      case DIVIDE:
        t = jj_consume_token(DIVIDE);
                                 tokenArr.add(t);
        T(project);
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
  }

  final protected void F(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t,t2;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OPEN_PAR:
      t = jj_consume_token(OPEN_PAR);
                                   tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                                                                      tokenArr.add(t);
      break;
    case TRUE:
      t = jj_consume_token(TRUE);
                                   tokenArr.add(t);
      break;
    case FALSE:
      t = jj_consume_token(FALSE);
                                   tokenArr.add(t);
      break;
    default:
      jj_la1[18] = jj_gen;
      if (jj_2_2(2)) {
        t = jj_consume_token(INTEGER);
                                               tokenArr.add(t);
        t = jj_consume_token(PERCENT);
                                                                                      tokenArr.add(t);
      } else if (jj_2_3(2)) {
        t = jj_consume_token(INTEGER);
                                               tokenArr.add(t);
        t = jj_consume_token(METER);
                                                                                      tokenArr.add(t);
      } else if (jj_2_4(2)) {
        t = jj_consume_token(INTEGER);
                                               tokenArr.add(t);
        t = jj_consume_token(DEGREE);
                                                                                      tokenArr.add(t);
      } else if (jj_2_5(2)) {
        t = jj_consume_token(FLOAT);
                                               tokenArr.add(t);
        t = jj_consume_token(PERCENT);
                                                                                      tokenArr.add(t);
      } else if (jj_2_6(2)) {
        t = jj_consume_token(FLOAT);
                                               tokenArr.add(t);
        t = jj_consume_token(METER);
                                                                                      tokenArr.add(t);
      } else if (jj_2_7(2)) {
        t = jj_consume_token(FLOAT);
                                               tokenArr.add(t);
        t = jj_consume_token(DEGREE);
                                                                                      tokenArr.add(t);
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INTEGER:
          t = jj_consume_token(INTEGER);
                                  tokenArr.add(t);
          break;
        case FLOAT:
          t = jj_consume_token(FLOAT);
                                tokenArr.add(t);
          break;
        case NBCELLNEU:
        case NBCELLMOO:
        case NBCELLSQ:
        case NBCELLCIR:
        case PCELLSQ:
        case PCELLCIR:
        case NBCELLANG:
        case PCELLANG:
        case CELLDURATION:
        case NORTH:
        case SOUTH:
        case EAST:
        case WEST:
        case NORTH_EAST:
        case NORTH_WEST:
        case SOUTH_EAST:
        case SOUTH_WEST:
        case NBCELL:
        case PCELL:
        case STEP:
        case NBSAMESTEP:
        case NBCELLDURATION:
        case RANDOM:
        case INT:
        case ROUND:
        case NAME:
          S(project);
          break;
        default:
          jj_la1[19] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
  }

  final protected void S(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t,t2;
    if (jj_2_8(2)) {
      t = jj_consume_token(NAME);
                        if (project.isLayerExists(t.image))
                                { tokenArr.add(t); }
                        else {
                            {if (true) throw new UnknownLayerException(t.image);}
                        }
      t = jj_consume_token(INTERRO);
                                   tokenArr.add(t);
      t = jj_consume_token(INTEGER);
                                                                        tokenArr.add(t);
    } else if (jj_2_9(2)) {
      t2 = jj_consume_token(NAME);
      t = jj_consume_token(DOT);
                        if(project.isLayerExists(t2.image)) {
                                 tokenArr.add(t2);
                        } else {
                            {if (true) throw new UnknownLayerException(t2.image);}
                        }
                  tokenArr.add(t);
      D(project);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NAME:
        /*NAME (STATE or LAYER)*/
        
                        t = jj_consume_token(NAME);
                          if(project.isLayerExists(t.image)) {
                              tokenArr.add(t);
                          } else {
                              if (project.getStates().getState(t.image).getValue() > -1) {
                                  tokenArr.add(t);
                              } else {
                                  {if (true) throw new UnknownStateException(t.image);}
                              }
                          }
        break;
      case NBCELLNEU:
      case NBCELLMOO:
      case NBCELLSQ:
      case NBCELLCIR:
      case PCELLSQ:
      case PCELLCIR:
      case NBCELLANG:
      case PCELLANG:
      case CELLDURATION:
      case NORTH:
      case SOUTH:
      case EAST:
      case WEST:
      case NORTH_EAST:
      case NORTH_WEST:
      case SOUTH_EAST:
      case SOUTH_WEST:
      case NBCELL:
      case PCELL:
      case STEP:
      case NBSAMESTEP:
      case NBCELLDURATION:
      case RANDOM:
      case INT:
      case ROUND:
        L(project);
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
  }

  final protected void L(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STEP:
      t = jj_consume_token(STEP);
                               tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                     tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                            tokenArr.add(t);
      break;
    case NBSAMESTEP:
      t = jj_consume_token(NBSAMESTEP);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                  tokenArr.add(t);
      break;
    case NBCELLDURATION:
      t = jj_consume_token(NBCELLDURATION);
                                         tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                               tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                                 tokenArr.add(t);
      break;
    case RANDOM:
      t = jj_consume_token(RANDOM);
                                 tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                       tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                              tokenArr.add(t);
      break;
    case INT:
      t = jj_consume_token(INT);
                              tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                      tokenArr.add(t);
      break;
    case ROUND:
      t = jj_consume_token(ROUND);
                                tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                      tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                        tokenArr.add(t);
      break;
    case NBCELL:
      t = jj_consume_token(NBCELL);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                     tokenArr.add(t);
      break;
    case PCELL:
      t = jj_consume_token(PCELL);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                     tokenArr.add(t);
      break;
    case NBCELLNEU:
    case NBCELLMOO:
    case NBCELLSQ:
    case NBCELLCIR:
    case PCELLSQ:
    case PCELLCIR:
    case NBCELLANG:
    case PCELLANG:
    case CELLDURATION:
    case NORTH:
    case SOUTH:
    case EAST:
    case WEST:
    case NORTH_EAST:
    case NORTH_WEST:
    case SOUTH_EAST:
    case SOUTH_WEST:
      D(project);
      break;
    default:
      jj_la1[21] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final protected void D(Project project) throws ParseException, NumberFormatException, UnknownStateException, UnknownLayerException {
        Token t;
        if(conditionBlock) {
            throw new IllegalArgumentException("No local function in condition block.");
        }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NBCELLNEU:
      /*nbCellNeu*/
                      t = jj_consume_token(NBCELLNEU);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                          tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case NBCELLMOO:
      t = jj_consume_token(NBCELLMOO);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                          tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case NBCELLSQ:
      t = jj_consume_token(NBCELLSQ);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case NBCELLCIR:
      t = jj_consume_token(NBCELLCIR);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case PCELLSQ:
      t = jj_consume_token(PCELLSQ);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case PCELLCIR:
      t = jj_consume_token(PCELLCIR);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case NBCELLANG:
      t = jj_consume_token(NBCELLANG);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case PCELLANG:
      t = jj_consume_token(PCELLANG);
                                    tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(COMMA);
                                    tokenArr.add(t);
      O(project);
      t = jj_consume_token(CLOSE_PAR);
                                    tokenArr.add(t);
      break;
    case NORTH:
      t = jj_consume_token(NORTH);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case SOUTH:
      t = jj_consume_token(SOUTH);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case EAST:
      t = jj_consume_token(EAST);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case WEST:
      t = jj_consume_token(WEST);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case NORTH_EAST:
      t = jj_consume_token(NORTH_EAST);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case NORTH_WEST:
      t = jj_consume_token(NORTH_WEST);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case SOUTH_EAST:
      t = jj_consume_token(SOUTH_EAST);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case SOUTH_WEST:
      t = jj_consume_token(SOUTH_WEST);
                                     tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                           tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    case CELLDURATION:
      t = jj_consume_token(CELLDURATION);
                                       tokenArr.add(t);
      t = jj_consume_token(OPEN_PAR);
                                                                             tokenArr.add(t);
      t = jj_consume_token(CLOSE_PAR);
                                                                                                                   tokenArr.add(t);
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  private boolean jj_3_7() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_scan_token(DEGREE)) return true;
    return false;
  }

  private boolean jj_3_6() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_scan_token(METER)) return true;
    return false;
  }

  private boolean jj_3_8() {
    if (jj_scan_token(NAME)) return true;
    if (jj_scan_token(INTERRO)) return true;
    return false;
  }

  private boolean jj_3_1() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_scan_token(NAME)) return true;
    return false;
  }

  private boolean jj_3_5() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_scan_token(PERCENT)) return true;
    return false;
  }

  private boolean jj_3_4() {
    if (jj_scan_token(INTEGER)) return true;
    if (jj_scan_token(DEGREE)) return true;
    return false;
  }

  private boolean jj_3_3() {
    if (jj_scan_token(INTEGER)) return true;
    if (jj_scan_token(METER)) return true;
    return false;
  }

  private boolean jj_3_9() {
    if (jj_scan_token(NAME)) return true;
    if (jj_scan_token(DOT)) return true;
    return false;
  }

  private boolean jj_3_2() {
    if (jj_scan_token(INTEGER)) return true;
    if (jj_scan_token(PERCENT)) return true;
    return false;
  }

  /** Generated Token Manager. */
  public AnalyzerTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  private int jj_gen;
  final private int[] jj_la1 = new int[23];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static {
      jj_la1_init_0();
      jj_la1_init_1();
      jj_la1_init_2();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20,0x80,0x40,0xff800700,0x1f800,0x1f800,0x60000,0x60000,0x200000,0x180000,0x180000,0x600,0xff800000,0xff800000,0xff800000,0xff800000,};
   }
   private static void jj_la1_init_1() {
      jj_la1_1 = new int[] {0x80070000,0x0,0x0,0x0,0x0,0x80070000,0x0,0x0,0x0,0x0,0x2000ffff,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000000,0xffff,0xffff,0xffff,0xff,};
   }
   private static void jj_la1_init_2() {
      jj_la1_2 = new int[] {0x1002,0x1002,0x1002,0x1002,0x1002,0x1002,0x1002,0x0,0x0,0x0,0x1060,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1060,0x1000,0x0,0x0,};
   }
  final private JJCalls[] jj_2_rtns = new JJCalls[9];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  /** Constructor with InputStream. */
  public Analyzer(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding. */
  public Analyzer(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new AnalyzerTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor. */
  public Analyzer(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new AnalyzerTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Constructor with generated Token Manager. */
  public Analyzer(AnalyzerTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  /** Reinitialise. */
  public void ReInit(AnalyzerTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 23; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Iterator<?> it = jj_expentries.iterator(); it.hasNext();) {
        exists = true;
        int[] oldentry = (int[])(it.next());
        if (oldentry.length == jj_expentry.length) {
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.add(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[77];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 23; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 77; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

  private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 9; i++) {
    try {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
          }
        }
        p = p.next;
      } while (p != null);
      } catch(LookaheadSuccess ls) { }
    }
    jj_rescan = false;
  }

  private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

        }
